Bug 1752158 - Review Request: termbox - Legacy-free alternative to ncurses
Summary: Review Request: termbox - Legacy-free alternative to ncurses
Keywords:
Status: POST
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
unspecified
medium
Target Milestone: ---
Assignee: Robert-André Mauchin 🐧
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: FE-NEEDSPONSOR 1752233
TreeView+ depends on / blocked
 
Reported: 2019-09-13 22:19 UTC by as
Modified: 2021-03-22 13:26 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed:
Type: ---
zebob.m: fedora-review+


Attachments (Terms of Use)

Description as 2019-09-13 22:19:49 UTC
Spec URL: https://raw.githubusercontent.com/adsr/termbox/rpm/rpm/termbox.spec
SRPM URL: https://github.com/adsr/termbox/blob/rpm/rpm/termbox-1.1.2-1.fc30.src.rpm?raw=true

Description:

(This is the C version of golang-github-nsf-termbox[0].)

Termbox is a library that provides minimalistic API which allows the 
programmer to write text-based user interfaces.

It is based on a very simple abstraction. The main idea is viewing 
terminals as a table of fixed-size cells and input being a stream of 
structured messages. Would be fair to say that the model is inspired 
by windows console API. The abstraction itself is not perfect and it 
may create problems in certain areas. The most sensitive ones are 
copy & pasting and wide characters (mostly Chinese, Japanese, Korean 
(CJK) characters). When it comes to copy & pasting, the notion of 
cells is not really compatible with the idea of text. And CJK runes 
often require more than one cell to display them nicely. Despite the 
mentioned flaws, using such a simple model brings benefits in a form 
of simplicity. And KISS principle is important.

At this point one should realize, that CLI (command-line interfaces) 
aren't really a thing termbox is aimed at. But rather 
pseudo-graphical user interfaces.

Fedora Account System Username: adsr

[0] https://src.fedoraproject.org/rpms/golang-github-nsf-termbox

Comment 1 Robert-André Mauchin 🐧 2019-09-23 13:14:15 UTC
 - Use a better name for your archive:

Source:          https://github.com/nsf/termbox/archive/v%{version}/%{name}-%{version}.tar.gz

 - devel must require the main package:

Requires:       %{name}%{?_isa} = %{version}-%{release}

See https://docs.fedoraproject.org/en-US/packaging-guidelines/#_requiring_base_package

 - static library are generally not packaged in Fedora, you should instead drop the extra file in %install:

rm -rf $RPM_BUILD_ROOT%{_libdir}/*.{a,la}

See https://docs.fedoraproject.org/en-US/packaging-guidelines/#packaging-static-libraries

 - unversionned so files go in the devel subpackage

%files
%{_libdir}/libtermbox.so.1
%{_libdir}/libtermbox.so.1.*

%files devel
%{_libdir}/libtermbox.so
%{_includedir}/termbox.h

See https://docs.fedoraproject.org/en-US/packaging-guidelines/#_devel_packages

 - You should add BuildRequires:  waf and run waf directly instead of using the provided copy

Comment 2 Robert-André Mauchin 🐧 2019-09-23 13:18:18 UTC
 - You must irstall the licences files with %license in %files, and you should install the README with %doc:

%files
%license COPYING
%doc README.md

Comment 4 Robert-André Mauchin 🐧 2019-09-30 13:37:46 UTC
 - You need to BR gcc:

+ waf configure --prefix=/usr --libdir=/usr/lib64 --includedir=/usr/include
Setting top to                           : /builddir/build/BUILD/termbox-1.1.2 
Setting out to                           : /builddir/build/BUILD/termbox-1.1.2/build 
Checking for 'gcc' (C compiler)          : not found 
Checking for 'clang' (C compiler)        : not found 
Checking for 'icc' (C compiler)          : not found 
Checking for 'c_bgxlc' (C compiler)      : not found 
Checking for 'c_emscripten' (C compiler) : not found 
Checking for 'c_nec' (C compiler)        : not found 
could not configure a C compiler!

 - You need to set default build flags (which includes -g):

%set_build_flags
waf configure \
    --prefix=%{_prefix} \
    --libdir=%{_libdir} \
    --includedir=%{_includedir}





Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[!]: If your application is a C or C++ application you must list a
     BuildRequires against gcc, gcc-c++ or clang.
[x]: Header files in -devel subpackage, if present.
[x]: ldconfig not called in %post and %postun for Fedora 28 and later.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.
[x]: Development (unversioned) .so files in -devel subpackage, if present.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Expat License", "Unknown or generated", "*No copyright* BSD
     3-clause "New" or "Revised" License". 18 files have unknown license.
     Detailed output of licensecheck in
     /home/bob/packaging/review/termbox/review-termbox/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[!]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in termbox-
     devel
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
     Note: gpgverify is not used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: No rpmlint messages.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: termbox-1.1.2-1.fc32.x86_64.rpm
          termbox-devel-1.1.2-1.fc32.x86_64.rpm
          termbox-debuginfo-1.1.2-1.fc32.x86_64.rpm
          termbox-debugsource-1.1.2-1.fc32.x86_64.rpm
          termbox-1.1.2-1.fc32.src.rpm
termbox.x86_64: W: spelling-error Summary(en_US) ncurses -> nurses, curses, n curses
termbox.x86_64: W: spelling-error %description -l en_US minimalistic -> minimalist, minimalism, animistic
termbox-devel.x86_64: W: no-documentation
termbox.src: W: spelling-error Summary(en_US) ncurses -> nurses, curses, n curses
termbox.src: W: spelling-error %description -l en_US minimalistic -> minimalist, minimalism, animistic
5 packages and 0 specfiles checked; 0 errors, 5 warnings.

Comment 5 Package Review 2020-09-30 00:45:22 UTC
This is an automatic check from review-stats script.

This review request ticket hasn't been updated for some time, but it seems
that the review is still being working out by you. If this is right, please
respond to this comment clearing the NEEDINFO flag and try to reach out the
submitter to proceed with the review.

If you're not interested in reviewing this ticket anymore, please clear the
fedora-review flag and reset the assignee, so that a new reviewer can take
this ticket.

Without any reply, this request will shortly be resetted.

Comment 6 as 2021-02-16 02:41:26 UTC
Updated. Note the original author is no longer maintaining and the repo URL has changed from nsf/termbox to termbox/termbox. The new repo has a simpler build (no waf) and one small bugfix. ABI version is unchanged.

Spec URL: https://raw.githubusercontent.com/termbox/termbox/rpm/termbox.spec
SRPM URL: https://github.com/termbox/termbox/blob/rpm/termbox-1.1.4-1.fc33.src.rpm?raw=true

Comment 7 Robert-André Mauchin 🐧 2021-03-04 10:10:25 UTC
Sorry I thought I had already taken care of this review.

Package approved.

Comment 8 Gwyn Ciesla 2021-03-22 13:26:38 UTC
(fedscm-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/termbox


Note You need to log in before you can comment on or make changes to this bug.